我的创作纪念日 CF1620D Exact Change 题解

2024-06-14 22:28

本文主要是介绍我的创作纪念日 CF1620D Exact Change 题解,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

突然发现自己在 CSDN 已经创作了 128 128 128 天,时间流逝得好快。

在这个特殊的日子里,发篇题解纪念一下。

link

题面翻译

  • n n n 个物品,第 i i i 个物品价格为 a i a_i ai
  • 有三种货币,面值分别为 1 , 2 , 3 1,2,3 1,2,3
  • 求最小需要多少张货币,才能表出所有的 a i a_i ai
  • 多组测试数据。
  • 1 ≤ t ≤ 1000 , 1 ≤ n ≤ 100 , 1 ≤ a i ≤ 1 0 9 1 \leq t \leq 1000,1 \leq n \leq 100,1 \leq a_i \leq 10^9 1t1000,1n100,1ai109

题目描述

One day, early in the morning, you decided to buy yourself a bag of chips in the nearby store. The store has chips of n n n different flavors. A bag of the i i i -th flavor costs a i a_i ai burles.

The store may run out of some flavors, so you’ll decide which one to buy after arriving there. But there are two major flaws in this plan:

  1. you have only coins of 1 1 1 , 2 2 2 and 3 3 3 burles;
  2. since it’s morning, the store will ask you to pay in exact change, i. e. if you choose the i i i -th flavor, you’ll have to pay exactly a i a_i ai burles.

Coins are heavy, so you’d like to take the least possible number of coins in total. That’s why you are wondering: what is the minimum total number of coins you should take with you, so you can buy a bag of chips of any flavor in exact change?

输入格式

The first line contains a single integer t t t ( 1 ≤ t ≤ 1000 1 \le t \le 1000 1t1000 ) — the number of test cases.

The first line of each test case contains the single integer n n n ( 1 ≤ n ≤ 100 1 \le n \le 100 1n100 ) — the number of flavors in the store.

The second line of each test case contains n n n integers a 1 , a 2 , … , a n a_1, a_2, \dots, a_n a1,a2,,an ( 1 ≤ a i ≤ 1 0 9 1 \le a_i \le 10^9 1ai109 ) — the cost of one bag of each flavor.

输出格式

For each test case, print one integer — the minimum number of coins you need to buy one bag of any flavor you’ll choose in exact change.

样例 #1

样例输入 #1

4
1
1337
3
10 8 10
5
1 2 3 4 5
3
7 77 777

样例输出 #1

446
4
3
260

提示

In the first test case, you should, for example, take with you $ 445 $ coins of value 3 3 3 and 1 1 1 coin of value 2 2 2 . So, 1337 = 445 ⋅ 3 + 1 ⋅ 2 1337 = 445 \cdot 3 + 1 \cdot 2 1337=4453+12 .

In the second test case, you should, for example, take $ 2 $ coins of value 3 3 3 and 2 2 2 coins of value 2 2 2 . So you can pay either exactly 8 = 2 ⋅ 3 + 1 ⋅ 2 8 = 2 \cdot 3 + 1 \cdot 2 8=23+12 or 10 = 2 ⋅ 3 + 2 ⋅ 2 10 = 2 \cdot 3 + 2 \cdot 2 10=23+22 .

In the third test case, it’s enough to take 1 1 1 coin of value 3 3 3 and 2 2 2 coins of value 1 1 1 .

思路

注意到货币的面值只能是 1 , 2 , 3 1,2,3 1,2,3,就从这一点特殊性质入手。

可以发现,面值为 1 1 1 的纸币不会超过 2 2 2 张,因为 2 2 2 1 1 1 元纸币相当于 1 1 1 2 2 2 元纸币,显然后者更优。

同理,面值为 2 2 2 的纸币不会超过 3 3 3 张,因为 3 3 3 2 2 2 元纸币相当于 2 2 2 3 3 3 元纸币,显然后者更优。

然后暴力枚举即可~

代码

#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll N=2e5+10,inf=1e9;
ll T,n,a[N],res;
ll solve(ll t,ll t1,ll t2){ll ct=inf; for(int i=0;i<=t1;i++)//面值为 1 的纸币数量for(int j=0;j<=t2;j++){//面值为 2 的纸币数量ll tmp=t-i-j*2;//剩余钱数if(tmp<0) continue;if(!(tmp%3)) ct=min(ct,tmp/3);//面值为 3 的纸币数量}return ct;
}
ll work(ll t1,ll t2){ll ans=-1;//面值为 3 的纸币数量最大值for(int i=1;i<=n;i++) ans=max(ans,solve(a[i],t1,t2));return ans+t1+t2;
}
int main(){ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);cin>>T;while(T--){cin>>n;res=inf;for(int i=1;i<=n;i++) cin>>a[i];for(int i=0;i<=1;i++)for(int j=0;j<=2;j++) res=min(res,work(i,j));cout<<res<<"\n";}return 0;
}

这篇关于我的创作纪念日 CF1620D Exact Change 题解的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1061665

相关文章

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

fzu 2277 Change 线段树

Problem 2277 Change Time Limit: 2000 mSec    Memory Limit : 262144 KB  Problem Description There is a rooted tree with n nodes, number from 1-n. Root’s number is 1.Each node has a value ai.

C - Word Ladder题解

C - Word Ladder 题解 解题思路: 先输入两个字符串S 和t 然后在S和T中寻找有多少个字符不同的个数(也就是需要变换多少次) 开始替换时: tips: 字符串下标以0开始 我们定义两个变量a和b,用于记录当前遍历到的字符 首先是判断:如果这时a已经==b了,那么就跳过,不用管; 如果a大于b的话:那么我们就让s中的第i项替换成b,接着就直接输出S就行了。 这样

【秋招笔试】9.07米哈游秋招改编题-三语言题解

🍭 大家好这里是 春秋招笔试突围,一起备战大厂笔试 💻 ACM金牌团队🏅️ | 多次AK大厂笔试 | 大厂实习经历 ✨ 本系列打算持续跟新 春秋招笔试题 👏 感谢大家的订阅➕ 和 喜欢💗 和 手里的小花花🌸 ✨ 笔试合集传送们 -> 🧷春秋招笔试合集 🍒 本专栏已收集 100+ 套笔试题,笔试真题 会在第一时间跟新 🍄 题面描述等均已改编,如果和你笔试题看到的题面描述

LeetCode 第414场周赛个人题解

目录 Q1. 将日期转换为二进制表示 原题链接 思路分析 AC代码 Q2. 范围内整数的最大得分 原题链接 思路分析 AC代码 Q3. 到达数组末尾的最大得分 原题链接 思路分析 AC代码 Q4. 吃掉所有兵需要的最多移动次数 原题链接 思路分析 AC代码 Q1. 将日期转换为二进制表示 原题链接 Q1. 将日期转换为二进制表示 思路分析

时间序列|change point detection

change point detection 被称为变点检测,其基本定义是在一个序列或过程中,当某个统计特性(分布类型、分布参数)在某时间点受系统性因素而非偶然因素影响发生变化,我们就称该时间点为变点。变点识别即利用统计量或统计方法或机器学习方法将该变点位置估计出来。 Change Point Detection的类型 online 指连续观察某一随机过程,监测到变点时停止检验,不运用到

牛客小白月赛100部分题解

比赛地址:牛客小白月赛100_ACM/NOI/CSP/CCPC/ICPC算法编程高难度练习赛_牛客竞赛OJ A.ACM中的A题 #include<bits/stdc++.h>using namespace std;#define ll long long#define ull = unsigned long longvoid solve() {ll a,b,c;cin>>a>>b>

P2858 [USACO06FEB] Treats for the Cows G/S 题解

P2858 题意 给一个数组。每天把最左或者最右的东西卖掉,第 i i i个东西,第 d a y day day天卖出的价格是 a [ i ] ∗ d a y a[i]*day a[i]∗day。 记忆化搜索 void dfs(int l,int r,int day,ll sum){if(v[l][r]>=sum)return;v[l][r]=sum;if(l>r)//这就是dp答案{

674 - Coin Change

一道很水的DP,但我做的时候也很费劲,由于存在面值为1的时候,所以所有面额都至少有1种方法。 推导出状态方程就是 dp(V,step) += dp(V - i * coin[step],step - 1); 其中V为当前的面值,coin[step]为硬币的面额,递归边界,如果step == 0(也就是递归到硬币面额为1的时候,返回1); #include<cstdio>#include<